`timescale 1ns / 1ps
module weckertop;

`define CLKLO	50
`define CLKHI	50
`define CLKPRD	(`CLKLO+`CLKHI)

reg clk;
reg reset;
reg set_time;
reg set_alarm;
reg set_hour;
reg set_min;
reg alarm_flag;
reg alarm_on_off;


	wecker Wecker( 
		sec_takt,
		set_time, set_alarm, set_hour, set_min,
		clk, reset, alarm_on_off,
		a_1, b_1, c_1, d_1, e_1, f_1, g_1,
		a_2, b_2, c_2, d_2, e_2, f_2, g_2,
		a_3, b_3, c_3, d_3, e_3, f_3, g_3,
		a_4, b_4, c_4, d_4, e_4, f_4, g_4,

		alarm_out, alarm_anzeige     		 	
);
	initial
	begin
		$dumpfile("wecker.vcd");
		$dumpvars(0);
		reset = 0;
		set_hour = 0;
		set_min = 0;
		set_alarm = 0;
		alarm_flag = 0;
		set_time = 0;
		
		#(2 * `CLKPRD) reset = 1;
		#(2 * `CLKPRD) reset = 0;
		#(10 * `CLKPRD) SetTime(12,35);		//Set time to 12.35
		#(10 * `CLKPRD) SetAlarm(12,38);	//Set alarm to 12.38
		
		alarm_on_off = 1;	//Make alarm active
		#(500 * `CLKPRD) reset = 1;
		#(2 * `CLKPRD) reset = 0;
		$finish;
	end
	
	initial
	begin
		clk = 0;
		while(1)
		begin
			#`CLKLO clk = 1;
			#`CLKHI	clk = 0;
		end
	end
	
               task SetTime;
               	input [7:0] hour, min;

               	begin: SetTimeBlk
               	reg [7:0] SetCounter;

                      set_time = 1;
              	      set_min = 1;
              	      for (SetCounter = min + 1; SetCounter != 0; SetCounter = SetCounter - 1)
              	              @(posedge clk);
              	      set_min = 0;
		      set_hour = 1;
		      for (SetCounter = hour + 1; SetCounter != 0; SetCounter = SetCounter - 1)
              	              @(posedge clk);
              	      set_hour = 0;
              	      set_time = 0;
              	      end
               endtask

               task SetAlarm;
               	input [7:0] hour, min;
	
		begin: SetAlarmBlk
		reg [7:0] SetCounter;
			
	              set_alarm = 1;
	      	      
	      	      set_hour = 1;
	      	      for (SetCounter = hour + 1; SetCounter != 0; SetCounter = SetCounter - 1)
	      	              @(posedge clk);
	      	      set_hour = 0;
		      
		      set_min = 1;
	      	      for (SetCounter = min + 1; SetCounter != 0; SetCounter = SetCounter - 1)
	      	              @(posedge clk);
	      	      set_min = 0;
	      	      set_alarm = 0;
	      	      end
	endtask
endmodule
			
